<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/resources/SceneManager.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_b1edfc2c49307e65a973a203b2244023.html">resources</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">SceneManager.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="SceneManager_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &lt;<a class="code" href="Scene_8hpp.html">gui/Scene.hpp</a>&gt;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span> </div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span>{</div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno"><a class="line" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">    8</a></span><span class="keyword">enum class</span> <a class="code hl_enumeration" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">SceneType</a> {</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span>    <a class="code hl_enumvalue" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9a90589c47f06eb971d548591f23c285af">Custom</a> = 0,</div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span>    <a class="code hl_class" href="classgg_1_1MainMenu.html">MainMenu</a>,</div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span>    <a class="code hl_class" href="classgg_1_1NewGame.html">NewGame</a>,</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span>    <a class="code hl_class" href="classgg_1_1LoadGame.html">LoadGame</a>,</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span>    <a class="code hl_class" href="classgg_1_1Settings.html">Settings</a>,</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>    <a class="code hl_class" href="classgg_1_1Gameplay.html">Gameplay</a>,</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>    <a class="code hl_class" href="classgg_1_1PauseMenu.html">PauseMenu</a>,</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>    <a class="code hl_class" href="classgg_1_1ControlsMenu.html">ControlsMenu</a></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>};</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="classgg_1_1SceneManager.html">   19</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1SceneManager.html">SceneManager</a></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span>{</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="classgg_1_1SceneManager.html#a19e50b107c00485bfb4295a74a2111ba">   22</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1SceneManager.html#a19e50b107c00485bfb4295a74a2111ba">Init</a>();</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno"><a class="line" href="classgg_1_1SceneManager.html#a139c16f910b93062998904c24958cc1c">   23</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1SceneManager.html#a139c16f910b93062998904c24958cc1c">Destroy</a>();</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="classgg_1_1SceneManager.html#a5b0cc99803bd4e4d89cc5c6f9f830c26">   25</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1SceneManager.html#a5b0cc99803bd4e4d89cc5c6f9f830c26">GetScene</a>(<span class="keyword">const</span> <a class="code hl_enumeration" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">SceneType</a> &amp;) -&gt; <a class="code hl_class" href="classgg_1_1Scene.html">Scene</a> *;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="classgg_1_1SceneManager.html#aa58d9c7b40c4b366093d85a9b3fe4c76">   26</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1SceneManager.html#aa58d9c7b40c4b366093d85a9b3fe4c76">AddScene</a>(<span class="keyword">const</span> <a class="code hl_enumeration" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">SceneType</a> &amp;, <a class="code hl_class" href="classgg_1_1Scene.html">Scene</a> *scene);</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="classgg_1_1SceneManager.html#a0358b3c268b513673eca1de8990a5094">   28</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1SceneManager.html#a0358b3c268b513673eca1de8990a5094">SceneTypeToString</a>(<a class="code hl_enumeration" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">SceneType</a>) -&gt; <span class="keyword">const</span> std::string;</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="classgg_1_1SceneManager.html#a3727f01422988701752afde7ddb24931">   29</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1SceneManager.html#a3727f01422988701752afde7ddb24931">StringToSceneType</a>(<span class="keyword">const</span> std::string &amp;) -&gt; <a class="code hl_enumeration" href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">SceneType</a>;</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="classgg_1_1SceneManager.html#ab3d4dd3eef97fcdd732ef1092f5bb225">   31</a></span>    <a class="code hl_function" href="classgg_1_1SceneManager.html#ab3d4dd3eef97fcdd732ef1092f5bb225">SceneManager</a>() = <span class="keyword">delete</span>;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="classgg_1_1SceneManager.html#af7e0001ea2a90c81cfb37547ee0f67ff">   32</a></span>    <a class="code hl_function" href="classgg_1_1SceneManager.html#af7e0001ea2a90c81cfb37547ee0f67ff">~SceneManager</a>() = <span class="keyword">delete</span>;</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    <span class="keyword">static</span> <span class="keywordtype">bool</span> sInitialized;</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>    <span class="keyword">static</span> std::vector&lt;Scene *&gt; sSceneLibrary;</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span> </div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> NUM_OF_SCENES = 8; <span class="comment">// Change if new SceneType added/deleted</span></div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>};</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aScene_8hpp_html"><div class="ttname"><a href="Scene_8hpp.html">Scene.hpp</a></div></div>
<div class="ttc" id="aclassgg_1_1ControlsMenu_html"><div class="ttname"><a href="classgg_1_1ControlsMenu.html">gg::ControlsMenu</a></div><div class="ttdef"><b>Definition:</b> ControlsMenu.hpp:8</div></div>
<div class="ttc" id="aclassgg_1_1Gameplay_html"><div class="ttname"><a href="classgg_1_1Gameplay.html">gg::Gameplay</a></div><div class="ttdef"><b>Definition:</b> Gameplay.hpp:12</div></div>
<div class="ttc" id="aclassgg_1_1LoadGame_html"><div class="ttname"><a href="classgg_1_1LoadGame.html">gg::LoadGame</a></div><div class="ttdef"><b>Definition:</b> LoadGame.hpp:10</div></div>
<div class="ttc" id="aclassgg_1_1MainMenu_html"><div class="ttname"><a href="classgg_1_1MainMenu.html">gg::MainMenu</a></div><div class="ttdef"><b>Definition:</b> MainMenu.hpp:10</div></div>
<div class="ttc" id="aclassgg_1_1NewGame_html"><div class="ttname"><a href="classgg_1_1NewGame.html">gg::NewGame</a></div><div class="ttdef"><b>Definition:</b> NewGame.hpp:10</div></div>
<div class="ttc" id="aclassgg_1_1PauseMenu_html"><div class="ttname"><a href="classgg_1_1PauseMenu.html">gg::PauseMenu</a></div><div class="ttdef"><b>Definition:</b> PauseMenu.hpp:8</div></div>
<div class="ttc" id="aclassgg_1_1SceneManager_html"><div class="ttname"><a href="classgg_1_1SceneManager.html">gg::SceneManager</a></div><div class="ttdef"><b>Definition:</b> SceneManager.hpp:20</div></div>
<div class="ttc" id="aclassgg_1_1SceneManager_html_a0358b3c268b513673eca1de8990a5094"><div class="ttname"><a href="classgg_1_1SceneManager.html#a0358b3c268b513673eca1de8990a5094">gg::SceneManager::SceneTypeToString</a></div><div class="ttdeci">static auto SceneTypeToString(SceneType) -&gt; const std::string</div></div>
<div class="ttc" id="aclassgg_1_1SceneManager_html_a139c16f910b93062998904c24958cc1c"><div class="ttname"><a href="classgg_1_1SceneManager.html#a139c16f910b93062998904c24958cc1c">gg::SceneManager::Destroy</a></div><div class="ttdeci">static void Destroy()</div></div>
<div class="ttc" id="aclassgg_1_1SceneManager_html_a19e50b107c00485bfb4295a74a2111ba"><div class="ttname"><a href="classgg_1_1SceneManager.html#a19e50b107c00485bfb4295a74a2111ba">gg::SceneManager::Init</a></div><div class="ttdeci">static void Init()</div></div>
<div class="ttc" id="aclassgg_1_1SceneManager_html_a3727f01422988701752afde7ddb24931"><div class="ttname"><a href="classgg_1_1SceneManager.html#a3727f01422988701752afde7ddb24931">gg::SceneManager::StringToSceneType</a></div><div class="ttdeci">static auto StringToSceneType(const std::string &amp;) -&gt; SceneType</div></div>
<div class="ttc" id="aclassgg_1_1SceneManager_html_a5b0cc99803bd4e4d89cc5c6f9f830c26"><div class="ttname"><a href="classgg_1_1SceneManager.html#a5b0cc99803bd4e4d89cc5c6f9f830c26">gg::SceneManager::GetScene</a></div><div class="ttdeci">static auto GetScene(const SceneType &amp;) -&gt; Scene *</div></div>
<div class="ttc" id="aclassgg_1_1SceneManager_html_aa58d9c7b40c4b366093d85a9b3fe4c76"><div class="ttname"><a href="classgg_1_1SceneManager.html#aa58d9c7b40c4b366093d85a9b3fe4c76">gg::SceneManager::AddScene</a></div><div class="ttdeci">static void AddScene(const SceneType &amp;, Scene *scene)</div></div>
<div class="ttc" id="aclassgg_1_1SceneManager_html_ab3d4dd3eef97fcdd732ef1092f5bb225"><div class="ttname"><a href="classgg_1_1SceneManager.html#ab3d4dd3eef97fcdd732ef1092f5bb225">gg::SceneManager::SceneManager</a></div><div class="ttdeci">SceneManager()=delete</div></div>
<div class="ttc" id="aclassgg_1_1SceneManager_html_af7e0001ea2a90c81cfb37547ee0f67ff"><div class="ttname"><a href="classgg_1_1SceneManager.html#af7e0001ea2a90c81cfb37547ee0f67ff">gg::SceneManager::~SceneManager</a></div><div class="ttdeci">~SceneManager()=delete</div></div>
<div class="ttc" id="aclassgg_1_1Scene_html"><div class="ttname"><a href="classgg_1_1Scene.html">gg::Scene</a></div><div class="ttdef"><b>Definition:</b> Scene.hpp:18</div></div>
<div class="ttc" id="aclassgg_1_1Settings_html"><div class="ttname"><a href="classgg_1_1Settings.html">gg::Settings</a></div><div class="ttdef"><b>Definition:</b> Settings.hpp:9</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
<div class="ttc" id="anamespacegg_html_a185920557ea920066338d5dec2aa9cf9"><div class="ttname"><a href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9">gg::SceneType</a></div><div class="ttdeci">SceneType</div><div class="ttdef"><b>Definition:</b> SceneManager.hpp:8</div></div>
<div class="ttc" id="anamespacegg_html_a185920557ea920066338d5dec2aa9cf9a90589c47f06eb971d548591f23c285af"><div class="ttname"><a href="namespacegg.html#a185920557ea920066338d5dec2aa9cf9a90589c47f06eb971d548591f23c285af">gg::SceneType::Custom</a></div><div class="ttdeci">@ Custom</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
